import { DynamicModule, Provider } from '@nestjs/common';
import { Connection, ConnectionOptions } from '@typedorm/core';
import { TypeDormModuleAsyncOptions, TypeDormModuleOption } from './type-dorm.interface';
export declare class TypeDormModule {
    /**
     * Reigister typeDorm module for root,
     * use `InjectTypeDorm` to inject TypeDormConnection
     * ```ts
     * constructor(@InjectTypeDorm() private readonly connection: TypeDormConnection)
     * ```
     * @param connectionOptions
     * @returns DynamicModule
     */
    static forRoot(option: TypeDormModuleOption): {
        module: typeof TypeDormModule;
        providers: import("@nestjs/common").ValueProvider<Connection>[];
        exports: import("@nestjs/common").ValueProvider<Connection>[];
    };
    /**
     * Reigister typeDorm module for root async,
     * use `InjectTypeDorm` to inject TypeDormConnection
     * ```ts
     * constructor(@InjectTypeDorm() private readonly connection: TypeDormConnection)
     * ```
     * @param TypeDormModuleAsyncOptions
     * @returns DynamicModule
     */
    static forRootAsync(asyncOptions: TypeDormModuleAsyncOptions): DynamicModule;
    static createAsyncProviders(options: TypeDormModuleAsyncOptions): Provider[];
    static createAsyncOptionsProvider({ name, ...options }: TypeDormModuleAsyncOptions): Provider<ConnectionOptions>;
    /**
     * Reigister typeDorm module for root,
     * do not require using `InjectTypeDorm` to inject TypeDormConnection
     * ```ts
     * constructor(
     *  private readonly connection: TypeDormConnection,
     * ) {}
     * ```
     * @param connectionOptions
     * @returns DynamicModule
     */
    static forRootNonInjection(connectionOptions: ConnectionOptions): DynamicModule;
}
